#pragma once
#include <ctype.h>
#include <SDL/SDL.h>

/**
 * @brief Check to see if k is in ascii area.
 */
#define lstd_checkascii(k) ((k & 0xff) == k)

/**
 * @brief Check see if a key is alpha.
 */
#define lstd_isalpha(k) (lstd_checkascii(k) ? isalpha(k) : 0)

/**
 * @brief Check see if a key is alphanumeric.
 */
#define lstd_isalnum(k) (lstd_checkascii(k) ? isalnum(k) : 0)

/**
 * @brief Check see if a key is a control character.
 */
#define lstd_iscntrl(k) (lstd_checkascii(k) ? iscntrl(k) : 0)

/**
 * @brief Check to see if a key is a space character.
 */
#define lstd_isspace(k) (lstd_checkascii(k) ? isspace(k) : 0)

/**
 * @brief Convert a key to lowercase if applicable.
 */
#define lstd_tolower(k) (lstd_checkascii(k) ? (SDLKey)tolower(k) : k)

/**
 * @brief Convert a key to uppercase if applicable.
 */
#define lstd_toupper(k) (lstd_checkascii(k) ? (SDLKey)toupper(k) : k)

